﻿#include <wiringPi.h>
#include <mcp23017.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/time.h>
#include <iostream>
#include <string>
#include <string.h>
#include <sstream>
#include <sys/stat.h>
#include <sys/types.h>
#include <fstream>
#include <ctime>
#include <iomanip>
#include <dirent.h>

using namespace std;

#define Q2W_BASEINPUT        						100
#define Q2W_BASEOUTPUT        						164

#define InterrupteurChambreNous   		  	 		1700
#define InterrupteurSdB1       						200
#define InterrupteurSdB2       						300
#define InterrupteurChambreSud	 		    		400
#define InterrupteurBiblio       					500
#define InterrupteurChambreEst 					600
#define InterrupteurCouloirVersChambreEst 		700
#define InterrupteurCouloirVersBiblio				800
#define InterrupteurCouloirVersChambreNous			900
#define InterrupteurWC				 				1000
#define InterrupteurCouloirVersEscalier				1100
#define InterrupteurChambreNousBis		  		 	100
#define InterrupteurSdB1Bis       					1800
#define InterrupteurSdB2Bis       					1900
#define InterrupteurChambreSudBis	 		    	2000
#define InterrupteurBiblioBis       				2100
#define InterrupteurChambreEstBis 				2200
#define InterrupteurCouloirVersChambreEstBis 	2300
#define InterrupteurCouloirVersBiblioBis			2400
#define InterrupteurCouloirVersChambreNousBis		2500
#define InterrupteurWCBis				 			2600
#define InterrupteurCouloirVersEscalierBis			2700

#define ScenariosExternesSerrure       				19900
#define SEOuvreSerrure								1
#define SEFermeSerrure								2
#define SEOuvreSerrureAndroid						9
#define SEFermeSerrureAndroid						8
#define SEFermetureSerrureTempo10s					4

#define ScenariosExternes       					9900

#define SEOuvertureGarage                			3
#define SERelacheBoutonGarage             			4
#define SEOuvertureInterphone           			1
#define SERelacheBoutonInterphone       			2
#define SEOuvertureInterphoneDouble     			5
#define SERelacheBoutonInterphonerelance30s 		6
#define SEDemandeImpulsionsCompteurEau  			20

#define ZoneChauffageBiblio							0 //ne gere pas les 6 ordres car sur un vrai relais
#define ZoneChauffageChambreNous					1
#define ZoneChauffageChambreEst					2
#define ZoneChauffageChambreSud						3
#define ZoneChauffageSdb							4

#define SceneChauffageBiblioArret 					4001
#define SceneChauffageBiblioHorsGel					4002
#define SceneChauffageBiblioEco						4003
#define SceneChauffageBiblioNormal					4004
#define SceneChauffageChambreNousArret		    	4101
#define SceneChauffageChambreNousHorsGel	    	4102
#define SceneChauffageChambreNousEco		    	4103
#define SceneChauffageChambreNousNormal		    	4104
#define SceneChauffageChambreNousPlus1		    	4105
#define SceneChauffageChambreNousPlus2		    	4106
#define SceneChauffageChambreEstArret	    	4201
#define SceneChauffageChambreEstHorsGel   		4202
#define SceneChauffageChambreEstEco		    	4203
#define SceneChauffageChambreEstNormal    		4204
#define SceneChauffageChambreEstPlus1   		4205
#define SceneChauffageChambreEstPlus2	  		4206
#define SceneChauffageChambreSudArret				4301
#define SceneChauffageChambreSudHorsGel				4302
#define SceneChauffageChambreSudEco					4303
#define SceneChauffageChambreSudNormal				4304
#define SceneChauffageChambreSudPlus1				4305
#define SceneChauffageChambreSudPlus2				4306
#define SceneChauffageSdbArret						4401
#define SceneChauffageSdbHorsGel					4402
#define SceneChauffageSdbEco						4403
#define SceneChauffageSdbNormal						4404
#define SceneChauffageSdbPlus1						4405
#define SceneChauffageSdbPlus2						4406

#define AppuiLong									90
#define ClicSimple									1
#define ClicDouble									2
#define ClicTriple									3

#define LumiereChambreNous   		1
#define LumiereSdB1       			2
#define LumiereSdB2       			3
#define LumiereSdBMiroir   			4
#define LumiereChambreSud   		5
#define LumiereBiblio       		6
#define LumiereChambreEst 		7
#define LumiereCouloir1       		508   //attention Relais inversé pour avoir une lumière de secours en cas de panne de la domotique
// au dela de 500 le relais est géré par les fonctions comme le nième en contact Normalement Fermé
#define LumiereCouloir2       		9
#define LumiereWC			 		510  //attention Relais inversé pour avoir une lumière de secours en cas de panne de la domotique
// le tableau électrique est dans le WC donc on a de la lumière quand on rebranche le raspberry après une sauvegarde par exemple

#define ScenariosStoppeVoletTempo       					9800

#define VoletRoulantChambreNous1   		17
#define VoletRoulantChambreNous2  		19
#define VoletRoulantSdB1                21
#define VoletRoulantSdB2                23
#define VoletRoulantSdB3                41
#define VoletRoulantChambreSud1         43
#define VoletRoulantChambreSud2         45
#define VoletRoulantBiblio              47
#define VoletRoulantChambreEst1     31
#define VoletRoulantChambreEst2     29

int TableauEtatVolet[50];

int TableauEtatBouton[32];
int64_t TableauTempsDepartClic[32];
int64_t TableauTempsFinClic[32];
int TableauNbClic[32];
int TableauActions[32];
int64_t TableauIntervalleTemps[32];
int64_t TableauTempsAppui[32];

int64_t NombreImpulsionCompteurEau;
int MemorisePassageParZero = 0;

int tableancienetatinput[32];
int tableancientempinput[32];
int tablenbclicinput[32];

bool isnumber(string chaine) {

	// cr�er un flux � partir de la cha�ne donn�e
	std::istringstream iss(chaine);
	// cr�er un objet temporaire pour la conversion
	float tmp;
	// tenter la conversion et
	// v�rifier qu'il ne reste plus rien dans la cha�ne
	return (iss >> tmp) && (iss.eof());

}

string inttostr(int64_t valeur) {
	// cr�er un flux de sortie
	std::ostringstream oss;
	// �crire un nombre dans le flux
	oss << valeur;
	// r�cup�rer une cha�ne de caract�res
	return oss.str();
}

int64_t strtoint(string chaine) {
	// cr�er un flux � partir de la cha�ne � convertir
	std::istringstream iss(chaine);
	// convertir en un int
	int64_t nombre;
	iss >> nombre;
	return nombre;
}

bool VerifierExistancefichier(string NomFichier) {

	std::ifstream fichier(NomFichier.c_str());
	return !fichier.fail();

}

bool CreerFichierAvecDateDedans(string NomFichier) {
	// std::ios_base::out est automatiquement ajout� par le
	// constructeur de std::ofstream

	ofstream file(NomFichier.c_str(), std::ios_base::app);

	char mbstr[100];
	time_t t = time(NULL);
	if (strftime(mbstr, 100, "%A %c", localtime(&t))) {
		cout << mbstr << "\t" << NomFichier << endl;
		file << mbstr << '\n';
	}
}

bool SupprimerFichier(string NomFichier) {
	remove(NomFichier.c_str());
}

// mode par d�faut 2 relais coup�, mode normal
// 2 relais allum�, 220V dessus, mode Eco
// Relais 1 seul allum�, phase positive, mode HorsGel
// Relais 2 seul allum�, phase n�gative, mode Arret
//
// pas encore de gestion du mode Confort -1 et confort -2 du 6 ordres

bool ChauffageModeNormal(int NumeroZone) {
	digitalWrite(Q2W_BASEOUTPUT + 46 + NumeroZone*2 - 2, 1);
	digitalWrite(Q2W_BASEOUTPUT + 46 + NumeroZone*2 - 1, 1);
	SupprimerFichier("/media/ramdiskNuit/EtatChauffage/" + inttostr(NumeroZone*100 + 1));
	SupprimerFichier("/media/ramdiskNuit/EtatChauffage/" + inttostr(NumeroZone*100 + 2));
	SupprimerFichier("/media/ramdiskNuit/EtatChauffage/" + inttostr(NumeroZone*100 + 3));
	SupprimerFichier("/media/ramdiskNuit/EtatChauffage/" + inttostr(NumeroZone*100 + 4));
	CreerFichierAvecDateDedans("/media/ramdiskNuit/EtatChauffage/" + inttostr(NumeroZone*100 + 4));
}

bool ChauffageModeEco(int NumeroZone) {
	digitalWrite(Q2W_BASEOUTPUT + 46 + NumeroZone*2 - 2, 0);
	digitalWrite(Q2W_BASEOUTPUT + 46 + NumeroZone*2 - 1, 0);
	SupprimerFichier("/media/ramdiskNuit/EtatChauffage/" + inttostr(NumeroZone*100 + 1));
	SupprimerFichier("/media/ramdiskNuit/EtatChauffage/" + inttostr(NumeroZone*100 + 2));
	SupprimerFichier("/media/ramdiskNuit/EtatChauffage/" + inttostr(NumeroZone*100 + 3));
	SupprimerFichier("/media/ramdiskNuit/EtatChauffage/" + inttostr(NumeroZone*100 + 4));
	CreerFichierAvecDateDedans("/media/ramdiskNuit/EtatChauffage/" + inttostr(NumeroZone*100 + 3));
}

bool ChauffageModeHorsGel(int NumeroZone) {
	digitalWrite(Q2W_BASEOUTPUT + 46 + NumeroZone*2 - 2, 0);
	digitalWrite(Q2W_BASEOUTPUT + 46 + NumeroZone*2 - 1, 1);
	SupprimerFichier("/media/ramdiskNuit/EtatChauffage/" + inttostr(NumeroZone*100 + 1));
	SupprimerFichier("/media/ramdiskNuit/EtatChauffage/" + inttostr(NumeroZone*100 + 2));
	SupprimerFichier("/media/ramdiskNuit/EtatChauffage/" + inttostr(NumeroZone*100 + 3));
	SupprimerFichier("/media/ramdiskNuit/EtatChauffage/" + inttostr(NumeroZone*100 + 4));
	CreerFichierAvecDateDedans("/media/ramdiskNuit/EtatChauffage/" + inttostr(NumeroZone*100 + 2));
}

bool ChauffageModeArret(int NumeroZone) {
	digitalWrite(Q2W_BASEOUTPUT + 46 + NumeroZone*2 - 2, 1);
	digitalWrite(Q2W_BASEOUTPUT + 46 + NumeroZone*2 - 1, 0);
	SupprimerFichier("/media/ramdiskNuit/EtatChauffage/" + inttostr(NumeroZone*100 + 1));
	SupprimerFichier("/media/ramdiskNuit/EtatChauffage/" + inttostr(NumeroZone*100 + 2));
	SupprimerFichier("/media/ramdiskNuit/EtatChauffage/" + inttostr(NumeroZone*100 + 3));
	SupprimerFichier("/media/ramdiskNuit/EtatChauffage/" + inttostr(NumeroZone*100 + 4));
	CreerFichierAvecDateDedans("/media/ramdiskNuit/EtatChauffage/" + inttostr(NumeroZone*100 + 1));
}

bool AllumeEclairage(int NumeroLampe) {
	int RelaisInverse = 0;
	if (NumeroLampe > 500) {
		RelaisInverse = 1;
		NumeroLampe = NumeroLampe - 500;
	}
	digitalWrite(Q2W_BASEOUTPUT + NumeroLampe - 1, RelaisInverse);
	CreerFichierAvecDateDedans("/media/ramdiskNuit/EtatRelais/" + inttostr(NumeroLampe));
}

bool EteindEclairage(int NumeroLampe) {
	int RelaisInverse = 1;
	if (NumeroLampe > 500) {
		RelaisInverse = 0;
		NumeroLampe = NumeroLampe - 500;
	}
	digitalWrite(Q2W_BASEOUTPUT + NumeroLampe - 1, RelaisInverse);
	SupprimerFichier("/media/ramdiskNuit/EtatRelais/" + inttostr(NumeroLampe));
}

bool BasculeEclairage(int NumeroLampe) {
	int RelaisInverse = 0;
	int OffsetInverse = 0;
	if (NumeroLampe > 500) {
		RelaisInverse = 1;
		OffsetInverse = 500;
	}

	if (digitalRead(Q2W_BASEOUTPUT + NumeroLampe - OffsetInverse - 1) == RelaisInverse) {
		EteindEclairage(NumeroLampe);
	}
	else {
		AllumeEclairage(NumeroLampe);
	}
}

bool SyncEclairage(int NumeroLampeCible, int NumeroLampeSource) {
	// met la lampe cible dans le même état que la lampe source
	int RelaisInverse = 1;
	if (NumeroLampeSource > 500) {
		RelaisInverse = 0;
		NumeroLampeSource = NumeroLampeSource - 500;
	}
	if (digitalRead(Q2W_BASEOUTPUT + NumeroLampeSource - 1) == RelaisInverse) {
		EteindEclairage(NumeroLampeCible);
	}
	else {
		AllumeEclairage(NumeroLampeCible);
	}
}

bool SyncEclairageExtinction(int NumeroLampeCible, int NumeroLampeSource) {
	// Eteind la lampe cible si la lampe source est eteinte
	int RelaisInverse = 1;
	if (NumeroLampeSource > 500) {
		RelaisInverse = 0;
		NumeroLampeSource = NumeroLampeSource - 500;
	}
	if (digitalRead(Q2W_BASEOUTPUT + NumeroLampeSource - 1) == RelaisInverse) {
		EteindEclairage(NumeroLampeCible);
	}
}

void DeclancheScenarioDelai(int NumeroScenario, int DecalageDixiemeSeconde) {
	// declenche un scenario après un délai en crééant un fichier qui sera relu.
	// cela veut dire que le scénario sera exécuté même si on redémarre le programme et que on a pas de tableau de délai à gérer
	int64_t tempsinstantane;
	int64_t tempsinstantaneSec;
	int64_t tempsinstantaneuSec;

	struct timeval tempintermediaire;

	gettimeofday(&tempintermediaire, NULL);
	tempsinstantaneSec = tempintermediaire.tv_sec;
	tempsinstantaneuSec = tempintermediaire.tv_usec;
	tempsinstantane = (tempsinstantaneSec * 1000000 + tempsinstantaneuSec) / 100000;

	CreerFichierAvecDateDedans("/media/ramdiskNuit/Scenarios/Delais/" + inttostr((tempsinstantane + DecalageDixiemeSeconde)*100000 + NumeroScenario));
}

void AnnulerScenariosDelais(int NumeroScenarioASupprimer) {
	// annule toutes planification d'un scénario
	/* Une structure qui contient les infos du dossier ou fichier actuel
	 (http://www.gnu.org/software/libc/manual/html_node/Directory-Entries.html) */
	struct dirent *lecture;

	/* Le dossier que l'on explore */
	DIR *rep;
	/* On ouvre le dossier */
	rep = opendir("/media/ramdiskNuit/Scenarios/Delais/");

	/* readdir retourne 1(true) si il a reussi a passer au fichier(ou dossier) suivant et 0 sinon
	 Donc tant qu'il a reussi a passer au fichier(ou dossier) suivant, on fait ce qui est dans la boucle */
	while ((lecture = readdir(rep))) {
		/* La tu verifie que c'est un fichier, (on peut appeler un dossier "dossier.mp3" et si t'essaies de le lire t'auras l'air fin...)
		 Tu verifies que c'est un mp3 (le nom du fichier est dans d_name) */
		std::string NomFichierTrouve(lecture->d_name, 0, 20);

		if (isnumber(NomFichierTrouve)) { // && VerifierExistancefichier(NomFichierTrouve)) {
			if (NumeroScenarioASupprimer == strtoint(NomFichierTrouve) % 100000) {
				SupprimerFichier("/media/ramdiskNuit/Scenarios/Delais/" + NomFichierTrouve);
			}
		}
	}
	/* Fermeture du dossier */
	closedir(rep);
}

bool MonteVolet(int NumeroVolet) {
	AnnulerScenariosDelais(ScenariosStoppeVoletTempo + NumeroVolet);
	digitalWrite(Q2W_BASEOUTPUT + NumeroVolet - 1, 1);
	SupprimerFichier("/media/ramdiskNuit/EtatRelais/" + inttostr(NumeroVolet));
	digitalWrite(Q2W_BASEOUTPUT + NumeroVolet, 0);
	CreerFichierAvecDateDedans("/media/ramdiskNuit/EtatRelais/" + inttostr(NumeroVolet + 1));
	DeclancheScenarioDelai(ScenariosStoppeVoletTempo + NumeroVolet, 100);
	TableauEtatVolet[NumeroVolet] = 1;
}

bool DescendVolet(int NumeroVolet) {
	AnnulerScenariosDelais(ScenariosStoppeVoletTempo + NumeroVolet);
	digitalWrite(Q2W_BASEOUTPUT + NumeroVolet, 1);
	SupprimerFichier("/media/ramdiskNuit/EtatRelais/" + inttostr(NumeroVolet + 1));
	digitalWrite(Q2W_BASEOUTPUT + NumeroVolet - 1, 0);
	CreerFichierAvecDateDedans("/media/ramdiskNuit/EtatRelais/" + inttostr(NumeroVolet));
	DeclancheScenarioDelai(ScenariosStoppeVoletTempo + NumeroVolet, 100);
	TableauEtatVolet[NumeroVolet] = -2;
}

bool StopVolet(int NumeroVolet) {
	AnnulerScenariosDelais(ScenariosStoppeVoletTempo + NumeroVolet);
	digitalWrite(Q2W_BASEOUTPUT + NumeroVolet - 1, 1);
	digitalWrite(Q2W_BASEOUTPUT + NumeroVolet, 1);
	SupprimerFichier("/media/ramdiskNuit/EtatRelais/" + inttostr(NumeroVolet));
	SupprimerFichier("/media/ramdiskNuit/EtatRelais/" + inttostr(NumeroVolet + 1));
	TableauEtatVolet[NumeroVolet] = TableauEtatVolet[NumeroVolet] + 1;
}

bool InverseVolet(int NumeroVolet) {
	if ((TableauEtatVolet[NumeroVolet] == 1) || (TableauEtatVolet[NumeroVolet] == -2)) {
		StopVolet(NumeroVolet);
	}
	else if (digitalRead(Q2W_BASEOUTPUT + NumeroVolet - 1) == 0) {
		MonteVolet(NumeroVolet);
	}
	else {
		DescendVolet(NumeroVolet);
	}
}

void DeclancheScenario(int NumeroScenario) {
	// boucle principale de déclanchement des scénarios.
	// switch en fonction du num�ro de sc�nario
	cout << "Scenario " << inttostr(NumeroScenario) << " lance" << endl;
	char command[100];
	switch (NumeroScenario) {
	case SceneChauffageChambreNousArret:
		ChauffageModeArret(ZoneChauffageChambreNous);
		break;
	case SceneChauffageChambreNousHorsGel:
		ChauffageModeHorsGel(ZoneChauffageChambreNous);
		break;
	case SceneChauffageChambreNousEco:
		ChauffageModeEco(ZoneChauffageChambreNous);
		break;
	case SceneChauffageChambreNousNormal:
		ChauffageModeNormal(ZoneChauffageChambreNous);
		break;
	case SceneChauffageSdbArret:
		ChauffageModeArret(ZoneChauffageSdb);
		break;
	case SceneChauffageSdbHorsGel:
		ChauffageModeHorsGel(ZoneChauffageSdb);
		break;
	case SceneChauffageSdbEco:
		ChauffageModeEco(ZoneChauffageSdb);
		break;
	case SceneChauffageSdbNormal:
		ChauffageModeNormal(ZoneChauffageSdb);
		break;
	case SceneChauffageChambreSudArret:
		ChauffageModeArret(ZoneChauffageChambreSud);
		break;
	case SceneChauffageChambreSudHorsGel:
		ChauffageModeHorsGel(ZoneChauffageChambreSud);
		break;
	case SceneChauffageChambreSudEco:
		ChauffageModeEco(ZoneChauffageChambreSud);
		break;
	case SceneChauffageChambreSudNormal:
		ChauffageModeNormal(ZoneChauffageChambreSud);
		break;
	case SceneChauffageBiblioArret:
		ChauffageModeArret(ZoneChauffageChambreSud);
		break;
	case SceneChauffageBiblioHorsGel:
		ChauffageModeHorsGel(ZoneChauffageChambreSud);
		break;
	case SceneChauffageBiblioEco:
		ChauffageModeEco(ZoneChauffageChambreSud);
		break;
	case SceneChauffageBiblioNormal:
		ChauffageModeNormal(ZoneChauffageChambreSud);
		break;
	case SceneChauffageChambreEstArret:
		ChauffageModeArret(ZoneChauffageChambreEst);
		break;
	case SceneChauffageChambreEstHorsGel:
		ChauffageModeHorsGel(ZoneChauffageChambreEst);
		break;
	case SceneChauffageChambreEstEco:
		ChauffageModeEco(ZoneChauffageChambreEst);
		break;
	case SceneChauffageChambreEstNormal:
		ChauffageModeNormal(ZoneChauffageChambreEst);
		break;

	case InterrupteurChambreNous + ClicSimple:
		BasculeEclairage(LumiereChambreNous);
		break;

	case InterrupteurSdB1 + ClicSimple:
		BasculeEclairage(LumiereSdB1);
		SyncEclairage(LumiereSdBMiroir, LumiereSdB1);
		SyncEclairageExtinction(LumiereSdB2, LumiereSdB1);
		break;
	case InterrupteurSdB1 + ClicDouble:
		BasculeEclairage(LumiereSdB2);
		break;

	case InterrupteurSdB2 + ClicSimple:
		BasculeEclairage(LumiereSdB2);
		break;

	case InterrupteurChambreSud + ClicSimple:
		BasculeEclairage(LumiereChambreSud);
		break;

	case InterrupteurBiblio + ClicSimple:
		BasculeEclairage(LumiereBiblio);
		break;

	case InterrupteurChambreEst + ClicSimple:
		BasculeEclairage(LumiereChambreEst);
		break;

	case InterrupteurCouloirVersChambreEst + ClicSimple:
		BasculeEclairage(LumiereCouloir1);
		SyncEclairage(LumiereCouloir2, LumiereCouloir1);

		break;

	case InterrupteurCouloirVersBiblio + ClicSimple:
		BasculeEclairage(LumiereCouloir1);
		SyncEclairage(LumiereCouloir2, LumiereCouloir1);
		break;

	case InterrupteurCouloirVersChambreNous + ClicSimple:
		BasculeEclairage(LumiereCouloir2);
		SyncEclairage(LumiereCouloir1, LumiereCouloir2);
		break;

	case InterrupteurWC + ClicSimple:
		BasculeEclairage(LumiereWC);
		break;

	case InterrupteurCouloirVersEscalier + ClicSimple:
		BasculeEclairage(LumiereCouloir1);
		SyncEclairage(LumiereCouloir2, LumiereCouloir1);
		SyncEclairage(LumiereChambreNous, LumiereCouloir1);
		SyncEclairage(LumiereSdB1, LumiereCouloir1);
		SyncEclairage(LumiereSdB2, LumiereCouloir1);
		SyncEclairage(LumiereSdBMiroir, LumiereCouloir1);
		SyncEclairage(LumiereChambreSud, LumiereCouloir1);
		SyncEclairage(LumiereBiblio, LumiereCouloir1);
		SyncEclairage(LumiereChambreEst, LumiereCouloir1);
		SyncEclairage(LumiereCouloir1, LumiereCouloir1);
		SyncEclairage(LumiereCouloir2, LumiereCouloir1);
		SyncEclairage(LumiereWC, LumiereCouloir1);

		break;
	case InterrupteurCouloirVersEscalier + ClicDouble:
		AllumeEclairage(LumiereChambreNous);
		AllumeEclairage(LumiereSdB1);
		AllumeEclairage(LumiereSdB2);
		AllumeEclairage(LumiereSdBMiroir);
		AllumeEclairage(LumiereChambreSud);
		AllumeEclairage(LumiereBiblio);
		AllumeEclairage(LumiereChambreEst);
		EteindEclairage(LumiereCouloir1);
		AllumeEclairage(LumiereCouloir2);
		EteindEclairage(LumiereWC);
		// Différents choix possibles

		// DeclancheScenarioDelai(ScenariosExternes + 14, 10);

		// AnnulerScenariosDelais(SERelacheBoutonInterphonerelance30s);

		// CreerFichierAvecDateDedans("/media/ramdiskNuit/Cause/Fermeture-Etage.mp3");

		// strcpy(command, "su tipi -c '/home/tipi/23017/BasculeBoule.sh'");
		// CreerFichierAvecDateDedans("/media/ramdiskNuit/ESP8266/OFF1.159");
		// system(command);

		break;

	case InterrupteurCouloirVersEscalier + AppuiLong: // eteind tout le haut
		EteindEclairage(LumiereChambreNous);
		EteindEclairage(LumiereSdB1);
		EteindEclairage(LumiereSdB2);
		EteindEclairage(LumiereSdBMiroir);
		EteindEclairage(LumiereChambreSud);
		EteindEclairage(LumiereBiblio);
		EteindEclairage(LumiereChambreEst);
		EteindEclairage(LumiereCouloir1);
		EteindEclairage(LumiereCouloir2);
		EteindEclairage(LumiereWC);
		break;

	case InterrupteurCouloirVersEscalierBis + ClicSimple:
		BasculeEclairage(LumiereCouloir1);
		SyncEclairage(LumiereCouloir2, LumiereCouloir1);
		SyncEclairage(LumiereChambreNous, LumiereCouloir1);
		SyncEclairage(LumiereSdB1, LumiereCouloir1);
		SyncEclairage(LumiereSdB2, LumiereCouloir1);
		SyncEclairage(LumiereSdBMiroir, LumiereCouloir1);
		SyncEclairage(LumiereChambreSud, LumiereCouloir1);
		SyncEclairage(LumiereBiblio, LumiereCouloir1);
		SyncEclairage(LumiereChambreEst, LumiereCouloir1);
		SyncEclairage(LumiereCouloir1, LumiereCouloir1);
		SyncEclairage(LumiereCouloir2, LumiereCouloir1);
		SyncEclairage(LumiereWC, LumiereCouloir1);

		// BasculeEclairage(LumiereCouloir1);
		break;
	case InterrupteurCouloirVersEscalierBis + ClicDouble: // Allume tout le haut
		AllumeEclairage(LumiereChambreNous);
		AllumeEclairage(LumiereSdB1);
		AllumeEclairage(LumiereSdB2);
		AllumeEclairage(LumiereSdBMiroir);
		AllumeEclairage(LumiereChambreSud);
		AllumeEclairage(LumiereBiblio);
		AllumeEclairage(LumiereChambreEst);
		AllumeEclairage(LumiereCouloir1);
		AllumeEclairage(LumiereCouloir2);
		AllumeEclairage(LumiereWC);
		break;

	case InterrupteurCouloirVersEscalierBis + AppuiLong: // Fermes Volet tout le haut
		DescendVolet(VoletRoulantChambreNous1);
		DescendVolet(VoletRoulantChambreNous2);
		DescendVolet(VoletRoulantSdB1);
		DescendVolet(VoletRoulantSdB2);
		DescendVolet(VoletRoulantSdB3);
		DescendVolet(VoletRoulantChambreSud1);
		DescendVolet(VoletRoulantChambreSud2);
		DescendVolet(VoletRoulantBiblio);
		DescendVolet(VoletRoulantChambreEst1);
		DescendVolet(VoletRoulantChambreEst2);
		break;

	case InterrupteurCouloirVersEscalierBis + ClicTriple: // Ouvre volets tout le haut

		MonteVolet(VoletRoulantChambreNous1);
		MonteVolet(VoletRoulantChambreNous2);
		MonteVolet(VoletRoulantSdB1);
		MonteVolet(VoletRoulantSdB2);
		MonteVolet(VoletRoulantSdB3);
		MonteVolet(VoletRoulantChambreSud1);
		MonteVolet(VoletRoulantChambreSud2);
		MonteVolet(VoletRoulantBiblio);
		MonteVolet(VoletRoulantChambreEst1);
		MonteVolet(VoletRoulantChambreEst2);
		break;

	case InterrupteurCouloirVersEscalierBis + 4: // Stoppe les volets tout le haut

		StopVolet(VoletRoulantChambreNous1);
		StopVolet(VoletRoulantChambreNous2);
		StopVolet(VoletRoulantSdB1);
		StopVolet(VoletRoulantSdB2);
		StopVolet(VoletRoulantSdB3);
		StopVolet(VoletRoulantChambreSud1);
		StopVolet(VoletRoulantChambreSud2);
		StopVolet(VoletRoulantBiblio);
		StopVolet(VoletRoulantChambreEst1);
		StopVolet(VoletRoulantChambreEst2);
		break;

	case ScenariosStoppeVoletTempo + VoletRoulantChambreNous1:
		StopVolet(VoletRoulantChambreNous1);
		break;
	case ScenariosStoppeVoletTempo + VoletRoulantChambreNous2:
		StopVolet(VoletRoulantChambreNous2);
		break;
	case ScenariosStoppeVoletTempo + VoletRoulantSdB1:
		StopVolet(VoletRoulantSdB1);
		break;
	case ScenariosStoppeVoletTempo + VoletRoulantSdB2:
		StopVolet(VoletRoulantSdB2);
		break;
	case ScenariosStoppeVoletTempo + VoletRoulantSdB3:
		StopVolet(VoletRoulantSdB3);
		break;
	case ScenariosStoppeVoletTempo + VoletRoulantChambreSud1:
		StopVolet(VoletRoulantChambreSud1);
		break;
	case ScenariosStoppeVoletTempo + VoletRoulantChambreSud2:
		StopVolet(VoletRoulantChambreSud2);
		break;
	case ScenariosStoppeVoletTempo + VoletRoulantBiblio:
		StopVolet(VoletRoulantBiblio);
		break;
	case ScenariosStoppeVoletTempo + VoletRoulantChambreEst1:
		StopVolet(VoletRoulantChambreEst1);
		break;
	case ScenariosStoppeVoletTempo + VoletRoulantChambreEst2:
		StopVolet(VoletRoulantChambreEst2);
		break;
	case InterrupteurChambreNousBis + ClicSimple:
		InverseVolet(VoletRoulantChambreNous1);
		InverseVolet(VoletRoulantChambreNous2);
		break;
	case InterrupteurSdB1Bis + ClicSimple:
		InverseVolet(VoletRoulantSdB1);

		InverseVolet(VoletRoulantSdB2);
		InverseVolet(VoletRoulantSdB3);
		break;
	case InterrupteurSdB2Bis + ClicSimple:
		InverseVolet(VoletRoulantSdB2);
		InverseVolet(VoletRoulantSdB3);
		break;
	case InterrupteurChambreSudBis + ClicSimple:
		InverseVolet(VoletRoulantChambreSud1);
		InverseVolet(VoletRoulantChambreSud2);
		break;
	case InterrupteurBiblioBis + ClicSimple:
		InverseVolet(VoletRoulantBiblio);
		break;
	case InterrupteurChambreEstBis + ClicSimple:
		InverseVolet(VoletRoulantChambreEst1);
		InverseVolet(VoletRoulantChambreEst2);
		break;

	case InterrupteurChambreNousBis + ClicDouble:
		InverseVolet(VoletRoulantChambreNous1);
		break;
	case InterrupteurSdB1Bis + ClicDouble:
		InverseVolet(VoletRoulantSdB1);
		break;
	case InterrupteurSdB2Bis + ClicDouble:
		InverseVolet(VoletRoulantSdB2);
		break;
	case InterrupteurChambreSudBis + ClicDouble:
		InverseVolet(VoletRoulantChambreSud1);
		break;
	case InterrupteurChambreEstBis + ClicDouble:
		InverseVolet(VoletRoulantChambreEst1);
		break;

	case InterrupteurChambreNousBis + ClicTriple:
		InverseVolet(VoletRoulantChambreNous2);
		break;
	case InterrupteurSdB1Bis + ClicTriple:
		InverseVolet(VoletRoulantSdB2);
		InverseVolet(VoletRoulantSdB2);
		break;
	case InterrupteurSdB2Bis + ClicTriple:
		InverseVolet(VoletRoulantSdB3);
		break;
	case InterrupteurChambreSudBis + ClicTriple:
		InverseVolet(VoletRoulantChambreSud2);
		break;
	case InterrupteurChambreEstBis + ClicTriple:
		InverseVolet(VoletRoulantChambreEst2);
		break;

	case InterrupteurChambreNousBis + AppuiLong:
		DescendVolet(VoletRoulantChambreNous1);
		DescendVolet(VoletRoulantChambreNous2);
		break;
	case InterrupteurSdB1Bis + AppuiLong:
		DescendVolet(VoletRoulantSdB1);
		DescendVolet(VoletRoulantSdB2);
		DescendVolet(VoletRoulantSdB3);
		break;
	case InterrupteurSdB2Bis + AppuiLong:
		DescendVolet(VoletRoulantSdB2);
		DescendVolet(VoletRoulantSdB3);
		break;
	case InterrupteurChambreSudBis + AppuiLong:
		DescendVolet(VoletRoulantChambreSud1);
		DescendVolet(VoletRoulantChambreSud2);
		break;
	case InterrupteurBiblioBis + AppuiLong:
		DescendVolet(VoletRoulantBiblio);
		break;
	case InterrupteurChambreEstBis + AppuiLong:
		DescendVolet(VoletRoulantChambreEst1);
		DescendVolet(VoletRoulantChambreEst2);
		break;

		//
		// VoletRoulantChambreNous1
		// VoletRoulantChambreNous2
		// VoletRoulantSdB1
		// VoletRoulantSdB2
		// VoletRoulantSdB3
		// VoletRoulantChambreSud1
		// VoletRoulantChambreSud2
		// VoletRoulantBiblio
		// VoletRoulantChambreEst1
		// VoletRoulantChambreEst2

		// tous ces boutons n'ont pas d'action
		// InterrupteurCouloirVersChambreEstBis
		// InterrupteurCouloirVersBiblioBis
		// InterrupteurCouloirVersChambreNousBis
		// InterrupteurWCBis

		// VoletRoulantChambreNous2
		// VoletRoulantSdB1
		// VoletRoulantSdB2
		// VoletRoulantSdB3
		// VoletRoulantChambreSud1
		// VoletRoulantChambreSud2
		// VoletRoulantBiblio
		// VoletRoulantChambreEst1
		// VoletRoulantChambreEst2

		//

	case ScenariosExternes + SEDemandeImpulsionsCompteurEau:
		// pour le moment renvoi un nombre de Clic juste pour tester le type d'affichage en php d'un compteur d'eau
		if (NombreImpulsionCompteurEau > 0) {
			CreerFichierAvecDateDedans("/media/ramdiskNuit/CompteurEau/" + inttostr(NombreImpulsionCompteurEau + 0));
			NombreImpulsionCompteurEau = 0;
			MemorisePassageParZero = 1;
		}
		else if (MemorisePassageParZero == 1) {
			MemorisePassageParZero = 0;
			CreerFichierAvecDateDedans("/media/ramdiskNuit/CompteurEau/0");
		}

		break;
	default:
		// d�cr�mente le sc�nario pour ex�cuter la plus grosse action
		// appel r�cursif � d�clanchesc�nario
		// si on a appuyé par exemple 4 fois sur l'interrupteur alors que il n'a pas d'action associée,
		// il va chercher le scénarion d'appui 3 fois, si il n'existe pas non plus il va lancer le scénarios appui double
		cout << "Pas de scenario pour cette action" << endl;
		if (NumeroScenario > 100) {
			if ((NumeroScenario % 100) > 1) {
				DeclancheScenario(NumeroScenario - 1);
			}
		}

		break;
	}
}

void SurveilleFichiersScenarios(void) {
	// si on crée un fichier par une autre méthode, python, bash, PHP,
	// le scénario sera déclanché
	// un simple fichier vide dans le répertoire suffit à déclancher le scénario correspondant.
	// en bash : touch /media/ramdiskNuit/Scenarios/101
	// et cela lancera le scénario 101 (InterrupteurChambreNousBis + ClicSimple)

	/* Une structure qui contient les infos du dossier ou fichier actuel
	 (http://www.gnu.org/software/libc/manual/html_node/Directory-Entries.html) */ struct dirent *lecture;

	/* Le dossier que l'on explore */ DIR *rep;

	/* On ouvre le dossier */ rep = opendir("/media/ramdiskNuit/Scenarios/");

	/* readdir retourne 1(true) si il a reussi a passer au fichier(ou dossier) suivant et 0 sinon
	 Donc tant qu'il a reussi a passer au fichier(ou dossier) suivant, on fait ce qui est dans la boucle */
	while ((lecture = readdir(rep))) {
		/* La tu verifie que c'est un fichier, (on peut appeler un dossier "dossier.mp3" et si t'essaies de le lire t'auras l'air fin...)
		 Tu verifies que c'est un mp3 (le nom du fichier est dans d_name) */ std::string NomFichierTrouve(lecture->d_name, 0, 10);

		if (isnumber(NomFichierTrouve)) { // && VerifierExistancefichier(NomFichierTrouve)) {
			DeclancheScenario(strtoint(NomFichierTrouve));
			SupprimerFichier("/media/ramdiskNuit/Scenarios/" + NomFichierTrouve);

		}

	}
	/* Fermeture du dossier */ closedir(rep);
}

void SurveilleFichiersScenariosDelais(int64_t tempsactuel) {
	/* Une structure qui contient les infos du dossier ou fichier actuel
	 (http://www.gnu.org/software/libc/manual/html_node/Directory-Entries.html) */ struct dirent *lecture;

	/* Le dossier que l'on explore */ DIR *rep;
	int64_t MomentDeclenchement;
	/* On ouvre le dossier */ rep = opendir("/media/ramdiskNuit/Scenarios/Delais/");

	/* readdir retourne 1(true) si il a reussi a passer au fichier(ou dossier) suivant et 0 sinon
	 Donc tant qu'il a reussi a passer au fichier(ou dossier) suivant, on fait ce qui est dans la boucle */
	while ((lecture = readdir(rep))) {
		/* La tu verifie que c'est un fichier, (on peut appeler un dossier "dossier.mp3" et si t'essaies de le lire t'auras l'air fin...)
		 Tu verifies que c'est un mp3 (le nom du fichier est dans d_name) */ std::string NomFichierTrouve(lecture->d_name, 0, 20);

		if (isnumber(NomFichierTrouve)) { // && VerifierExistancefichier(NomFichierTrouve)) {

			// le d�but du fichier contient le timestamp � partir de quand il faut le d�clencher, les 4 derniers chiffres contiennent le num�ro de Sc�nario
			MomentDeclenchement = strtoint(NomFichierTrouve) / 100000;
			if (MomentDeclenchement * 100 <= tempsactuel) {
				DeclancheScenario(strtoint(NomFichierTrouve) % 100000);
				SupprimerFichier("/media/ramdiskNuit/Scenarios/Delais/" + NomFichierTrouve);
			}

		}

	}
	/* Fermeture du dossier */ closedir(rep);
}

int surveilleinputs(void) {
	// Foncction principale de scrutation des entrées.
	// ne gère pas les interruptions du mcp23017 car la scrutation en C est bien assez rapide.
	//
	int i;
	int DureeAppuiLong;
	int IntervalleMultiClic;
	int64_t tempsinstantane;
	int64_t tempsinstantaneSec;
	int64_t tempsinstantaneuSec;

	struct timeval tempintermediaire;

	DureeAppuiLong = 500;
	// Attention l'action sera d�clench� apr�s l'intervalleMultiClic du dernier appui, ne pas mettre trop
	IntervalleMultiClic = 350;
	gettimeofday(&tempintermediaire, NULL);
	tempsinstantaneSec = tempintermediaire.tv_sec;
	tempsinstantaneuSec = tempintermediaire.tv_usec;
	tempsinstantane = (tempsinstantaneSec * 1000000 + tempsinstantaneuSec) / 1000;

	for (i = 0; i < 32; i++) {
		if (!digitalRead(Q2W_BASEINPUT + i)) {
			if (TableauEtatBouton[i] != 1) {
				if (TableauNbClic[i] == 0) { // m�morise le moment ou on a commencer l'appui pour �venement Appui long
					TableauTempsDepartClic[i] = tempsinstantane;
				}
				SupprimerFichier("/media/ramdiskNuit/EtatInterrupteur/" + inttostr(i + 1));
				TableauEtatBouton[i] = 1;
			}
		}
		else {
			if (TableauEtatBouton[i] == 1) { // m�morise le moment ou on a relacher l'appui pour compter les clics
				if (TableauTempsDepartClic[i] != 0) {
					TableauTempsFinClic[i] = tempsinstantane;
					TableauNbClic[i] = TableauNbClic[i] + 1;
					CreerFichierAvecDateDedans("/media/ramdiskNuit/EtatInterrupteur/" + inttostr(i + 1));
				}
				TableauEtatBouton[i] = 0;
			}
		}

		// ne scrute que s'il y a un d�but d'appui
		if (TableauTempsDepartClic[i] != 0) {
			// test l'appui long
			// simplement d�clench� si l'interrupteur est appuy� pendant un certain d�lai.
			// l'action est d�clench� d�s que le d�lai est atteint, que l'on reste longtemps en plus sur l'interrupteur ou pas
			// la valeur est � 90 si c'est un appui long
			if (TableauNbClic[i] == 0) {

				TableauTempsAppui[i]++;
				if (tempsinstantane - TableauTempsDepartClic[i] > DureeAppuiLong) {
					TableauActions[i] = 90;
					// r�initialise pour etre sur de ne pas avoir de multiples ordres
					TableauTempsDepartClic[i] = 0;
					TableauTempsFinClic[i] = 0;
					TableauNbClic[i] = 0;
				}
			}
			else {
				// test des clics
				// l'action est d�clench� si l'interrupteur n'est pas rappuy� pendant un certain temps
				//
				// l'action est d�clench�e ici  v dans le cas d'une tempo � 6 unit�s
				// ____________|--|____|--|____________
				// 00000000000011112345111123456 Action
				//
				// la valeur est �gale au nombre de clic

				// accepte un intervalle limit� sans appui, sinon d�clenche l'�v�nement
				TableauIntervalleTemps[i]++;
				if (tempsinstantane - TableauTempsFinClic[i] > IntervalleMultiClic) {
					TableauActions[i] = TableauNbClic[i];
					TableauTempsDepartClic[i] = 0;
					TableauTempsFinClic[i] = 0;
					TableauNbClic[i] = 0;
				}
			}
		}
		if (TableauActions[i] > 0) {
			// soit on lance directement l'appel du sc�nario, soit on creer le fichier.
			// les sc�narios des interrupteurs sont cod� en ( (num inter)*100 ) + code action
			// ainsi un appui long sur l'inter 7 sera cod� 790
			// un simple clic sera cod� 701
			// NombreImpulsionCompteurEau += TableauActions[i]*1000 + TableauIntervalleTemps[i]*100 + TableauTempsAppui[i];
			NombreImpulsionCompteurEau += TableauTempsAppui[i];
			// permet de connaitre le temps d'appui
			// apparement c'est aux alentours de 3 cycles si appui très court. tourne plutot à 10 à 15 cycles en appui standard
			// CreerFichierAvecDateDedans("/media/ramdiskNuit/Cause/Temps appui " + inttostr(TableauTempsAppui[i]) + ".spk");

			TableauIntervalleTemps[i] = 0;
			if (TableauTempsAppui[i] > 1) { // pour éviter les appuis parasites du au lave vaisselle, passage en mode Heure Creuse du Chauffe eau ou à l'ascenceur
				DeclancheScenario((i + 1) * 100 + TableauActions[i]);
			}

			TableauTempsAppui[i] = 0;
			// il faut commenter la ligne au dessus, pour activer cette ligne sinon le sc�nario se d�roulera 2 fois
			// CreerFichierAvecDateDedans("/media/ramdiskNuit/Scenarios/" + inttostr((i+1)*100+TableauActions[i]));

			// remet le tableau d'action � z�ro
			TableauActions[i] = 0;
		}
	}
	SurveilleFichiersScenarios();
	SurveilleFichiersScenariosDelais(tempsinstantane);

}

int main(int argc, char *argv[]) {
	int i;

	// Activer le GPIO sur de la carte

	wiringPiSetup();

	// Ajouter le mcp23017 sur la carte q2w

	mcp23017Setup(Q2W_BASEINPUT, 0x22);
	mcp23017Setup(Q2W_BASEINPUT + 16, 0x23);

	mcp23017Setup(Q2W_BASEOUTPUT, 0x24);
	mcp23017Setup(Q2W_BASEOUTPUT + 16, 0x25);
	mcp23017Setup(Q2W_BASEOUTPUT + 32, 0x21);
	mcp23017Setup(Q2W_BASEOUTPUT + 48, 0x20);

	NombreImpulsionCompteurEau = 0;

	// creer les r�pertoire dans le ramdisk
	mkdir("/media/ramdiskNuit/EtatTemperature", S_IRWXU | S_IRWXG | S_IRWXO);
	mkdir("/media/ramdiskNuit/EtatInterrupteur", S_IRWXU | S_IRWXG | S_IRWXO);
	mkdir("/media/ramdiskNuit/EtatRelais", S_IRWXU | S_IRWXG | S_IRWXO);
	mkdir("/media/ramdiskNuit/EtatPorte", S_IRWXU | S_IRWXG | S_IRWXO);
	mkdir("/media/ramdiskNuit/EtatChauffage", S_IRWXU | S_IRWXG | S_IRWXO);
	mkdir("/media/ramdiskNuit/Scenarios", S_IRWXU | S_IRWXG | S_IRWXO);
	mkdir("/media/ramdiskNuit/CompteurEau", S_IRWXU | S_IRWXG | S_IRWXO);
	mkdir("/media/ramdiskNuit/Serrure", S_IRWXU | S_IRWXG | S_IRWXO);
	mkdir("/media/ramdiskNuit/Serrure/Scenarios", S_IRWXU | S_IRWXG | S_IRWXO);
	mkdir("/media/ramdiskNuit/Scenarios/Delais", S_IRWXU | S_IRWXG | S_IRWXO);
	mkdir("/media/ramdiskNuit/Serrure/Scenarios/Delais", S_IRWXU | S_IRWXG | S_IRWXO);
	mkdir("/media/ramdiskNuit/Cause", S_IRWXU | S_IRWXG | S_IRWXO);
	// section qui parle ou envoi des sms avec incron
	mkdir("/media/ramdiskNuit/EtatRelaisESP", S_IRWXU | S_IRWXG | S_IRWXO);
	mkdir("/media/ramdiskNuit/ESP8266", S_IRWXU | S_IRWXG | S_IRWXO);
	// section qui donne des ordres au ESP avec incron
	//

	// SurveilleFichiersScenarios();

	string s1 = "Raspberry Pi - Ledonia MCP23017 \n";

	// printf("Raspberry Pi - Ledonia MCP23017 Test\n");
	cout << s1 << endl; // <================= Put a breakpoint here

	// D�clarer tous les pins des 2 mcp23017 0x22 et 0x23 comme entr�e ("input" en anglais).

	for (i = 0; i < 32; ++i) {
		pinMode(Q2W_BASEINPUT + i, INPUT);
		pullUpDnControl(Q2W_BASEINPUT + i, PUD_UP);
		// ce mode permet de faire le lien direct entre la broche du MCP23017 et la masse pour avoir l'entree sans recourrir à une résistance supplémentaire
	}

	// D�clarer tous les pins des 4 mcp23017 0x20, 0x21 0x24 0x25 comme sortie ("output" en anglais):

	for (i = 0; i < 64; ++i) {
		pinMode(Q2W_BASEOUTPUT + i, OUTPUT);
		// permet de conserver les sorties � l'�tat pr�c�dent lors d'un simple redémarrage du programme (n'éteint pas le salon quand votre femme y est juste pour une nouvelle compilation du programme
		// ne les conservent que si le fichier temp existe
		if (!VerifierExistancefichier("/media/ramdiskNuit/LedoniaInitialise")) {
			if (i >= 48) {
				digitalWrite(Q2W_BASEOUTPUT + i, 0);
			}
			else {
				// ne le fait pas pour celles qui gère les radiateurs
				digitalWrite(Q2W_BASEOUTPUT + i, 1);
			}
			// sinon ces 2 lampes sont allumés au démarrage de par leur branchement
			EteindEclairage(LumiereCouloir1); // attention Relais inversé pour avoir une lumière de secours en cas de panne de la domotique
			EteindEclairage(LumiereWC); // attention Relais inversé pour avoir une lumière de secours en cas de panne de la domotique
		}
	}

	// Affecte les relais carte Teleinfopi
	// directement des broches du raspberry
	pinMode(4, OUTPUT);
	digitalWrite(4, 0);
	pinMode(5, OUTPUT);
	digitalWrite(5, 0);

	CreerFichierAvecDateDedans("/media/ramdiskNuit/LedoniaInitialise");

	// La derni�re broches de la carte q2c comme entr�e et activer la
	// r�sistance Pull-Up interne

	// pinMode         (Q2W_BASE + 15, INPUT) ;
	// pullUpDnControl (Q2W_BASE + 15, PUD_UP) ;

	// struct timeval tempintermediaire;
	// int tempprecedent=0;
	while (true)
		// on devrait! On boucle jusqu'a ce que l'utilisateur appuie sur une touche
	{

		delay(0);
		surveilleinputs();
		// gettimeofday(&tempintermediaire, NULL);
		// permet d'afficher le temps de cycle
		// cout<< inttostr(tempintermediaire.tv_sec*1000000+tempintermediaire.tv_usec) << "   " <<   inttostr((tempintermediaire.tv_sec*1000000+tempintermediaire.tv_usec)/10 - tempprecedent) <<endl;
		// tempprecedent= (tempintermediaire.tv_sec*1000000+tempintermediaire.tv_usec )/10;
	}
	return 0;
}
